const GObject = imports.gi.GObject;
const Gtk = imports.gi.Gtk;

var Y901xHeaderBar = GObject.registerClass({
    GTypeName: "Y901xHeaderBar"
}, class Y901xHeaderBar extends Gtk.HeaderBar {
    constructor(props={}) {
        super(props);
    }
    create() {
        // Aspectrate Button
        this.aspectButton = new Gtk.Button({
            label: "source",
            can_focus: false
        });
        this.aspectButton.connect("clicked", ()=> {
            this.aspectMenu.show_all();
        });
        this.pack_start(this.aspectButton);
        let aspectRateBox = new Gtk.Box({orientation: Gtk.Orientation.VERTICAL});
        let aspectRateButtons = new Map([["win.source", "source"], ["win.hd", "16:9"], ["win.golden", "4:3"]]);
        for (let [buttonName, buttonLabel] of aspectRateButtons) {
            let button = new Gtk.ModelButton({
                action_name: buttonName,
                text: buttonLabel
            });
            aspectRateBox.pack_start(button, true, true, 0);
        }
        this.aspectMenu = new Gtk.PopoverMenu();
        this.aspectMenu.add(aspectRateBox);
        this.aspectMenu.set_relative_to(this.aspectButton);
        // Rotate Button
        this.rotateButton = new Gtk.Button({
            label: "0°",
            can_focus: false
        });
        this.rotateButton.connect("clicked", ()=> {
            this.rotateMenu.show_all();
        });
        this.pack_start(this.rotateButton);
        let rotateBox = new Gtk.Box({orientation: Gtk.Orientation.VERTICAL});
        let rotateButtons = new Map([["win.r0", "0°"], ["win.r90", "90°"], ["win.r180", "180°"], ["win.r270", "270°"]]);
        for (let [buttonName, buttonLabel] of rotateButtons) {
            let button = new Gtk.ModelButton({
                action_name: buttonName,
                text: buttonLabel
            });
            rotateBox.pack_start(button, true, true, 0);
        }
        this.rotateMenu = new Gtk.PopoverMenu();
        this.rotateMenu.add(rotateBox);
        this.rotateMenu.set_relative_to(this.rotateButton);
        //
        // Folder List
        let listbutton = new Gtk.Button({
            can_focus: false
        });
        let image_folder = Gtk.Image.new_from_icon_name("folder-symbolic", Gtk.IconSize.MENU);
        listbutton.set_image(image_folder);
        this.pack_end(listbutton);
        listbutton.connect("clicked", ()=> {
            this.listmenu.show_all();
        });
        // Popover
        this.listmenu = new Gtk.Popover();
        this.listmenu.set_relative_to(listbutton);
        // liststore  
        this.liststore = new Gtk.ListStore();
        this.liststore.set_column_types([GObject.TYPE_STRING]);
        // treeview
        this.treeview = new Gtk.TreeView({
            expand: true,
            headers_visible: false,
            model: this.liststore
        });
        let column1 = new Gtk.TreeViewColumn();
        let cell1 = new Gtk.CellRendererText();
        column1.pack_start(cell1, true);
        column1.add_attribute(cell1, "text", 0);
        this.treeview.append_column(column1);
        this.selection = this.treeview.get_selection();
        //selection.set_mode(Gtk.SelectionMode.SINGLE);
        this.openButton = new Gtk.Button({
            label: "Open"
        });
        this.repeat_single = new Gtk.ToggleButton({
            can_focus: false
        });
        let image_single = Gtk.Image.new_from_icon_name("media-playlist-repeat-song-symbolic", Gtk.IconSize.MENU);
        this.repeat_single.set_image(image_single);
        this.repeat_single.connect("toggled", (widget)=> {
            if (widget.get_active() && this.repeat_all.get_active())
                this.repeat_all.set_active(false);
        });
        this.repeat_all = new Gtk.ToggleButton({
            can_focus: false
        });
        let image_all = Gtk.Image.new_from_icon_name("media-playlist-repeat-symbolic", Gtk.IconSize.MENU);
        this.repeat_all.set_image(image_all);
        this.repeat_all.connect("toggled", (widget)=> {
            if (widget.get_active() && this.repeat_single.get_active())
                this.repeat_single.set_active(false);
        });
        let hbox = new Gtk.Box({orientation: Gtk.Orientation.HORIZONTAL});
        hbox.pack_start(this.repeat_single, true, true, 0);
        hbox.pack_start(this.repeat_all, true, true, 0);
        //
        let box = new Gtk.Box({orientation: Gtk.Orientation.VERTICAL});
        box.pack_start(this.openButton, true, true, 0);
        box.pack_start(hbox, true, true, 0);
        box.pack_start(this.treeview, true, true, 0);
        this.listmenu.add(box);
    }
    select_text(text) {
        let [res, it] = this.liststore.get_iter_first();
        if (!res) {
            this.selection.unselect_all();
        } else {
            for (;;) {
                let s = this.liststore.get_value(it, 0);
                if (s == text) {
                    this.selection.select_iter(it);
                    break;
                }
                let nx = this.liststore.iter_next(it);
                if (!nx) break;
            }
        }
    }
    next_file() {
        var [res, model, it] = this.selection.get_selected();
        if (res) {
            let nx = this.liststore.iter_next(it);
            if (nx) {
                let s = model.get_value(it, 0);
                return s;
            }
        }
        return null;
    }
    prev_file() {
        var [res, model, it] = this.selection.get_selected();
        if (res) {
            let nx = this.liststore.iter_previous(it);
            if (nx) {
                let s = model.get_value(it, 0);
                return s;
            }
        }
        return null;
    }
});
