const GObject = imports.gi.GObject;
const Gtk = imports.gi.Gtk;

var Y901xPreference = GObject.registerClass({
    GTypeName: "Y901xPreference"
}, class Y901xPreference extends Gtk.Dialog {

    constructor(props={}) {
        super({
            //use_header_bar: true,
            transient_for: window,
            title: "Y901x Preference"
        });
    }
    create() {
        // Set Size
        let slabel = new Gtk.Label({
            use_markup: true,
            xalign: 0,
            label: "<b>Set Size</b>"
        });
        let grid = new Gtk.Grid(); //Table(3, 4)
        this.sb = [];
        for (let i=0; i<6; i++) {
            this.sb.push(Gtk.SpinButton.new_with_range(0.0, 10000.0, 1.0));
        }
        this.sb[0].set_value(window.set_size[0][0])
        this.sb[1].set_value(window.set_size[0][1])
        this.sb[2].set_value(window.set_size[1][0])
        this.sb[3].set_value(window.set_size[1][1])
        this.sb[4].set_value(window.set_size[2][0])
        this.sb[5].set_value(window.set_size[2][1])
        let table_label = ["width", "height", "set1", "set2", "set3"];
        grid.attach(Gtk.Label.new(table_label[0]),1,0,1,1);
        grid.attach(Gtk.Label.new(table_label[1]),2,0,1,1);
        grid.attach(Gtk.Label.new(table_label[2]),0,1,1,1);
        grid.attach(Gtk.Label.new(table_label[3]),0,2,1,1);
        grid.attach(Gtk.Label.new(table_label[4]),0,3,1,1);
        grid.attach(this.sb[0],1,1,1,1);
        grid.attach(this.sb[1],2,1,1,1);
        grid.attach(this.sb[2],1,2,1,1);
        grid.attach(this.sb[3],2,2,1,1);
        grid.attach(this.sb[4],1,3,1,1);
        grid.attach(this.sb[5],2,3,1,1);
        //
        // ContentType
        let clabel = new Gtk.Label({
            use_markup: true,
            xalign: 0,
            label: "<b>ContentType</b>"
        });
        this.entry = new Gtk.Entry({
            text: window.types.join(",")
        });
        // hide signal
        this.connect("hide", Lang.bind(this, function() {
            window.set_size[0][0] = Number(this.sb[0].get_value());
            window.set_size[0][1] = Number(this.sb[1].get_value());
            window.set_size[1][0] = Number(this.sb[2].get_value());
            window.set_size[1][1] = Number(this.sb[3].get_value());
            window.set_size[2][0] = Number(this.sb[4].get_value());
            window.set_size[2][1] = Number(this.sb[5].get_value());
            //
            window.types = this.entry.text.split(",");
        }));
        //
        let vbox = this.get_content_area();
        vbox.border_width = 16;
        vbox.spacing = 16;
        vbox.pack_start(slabel, true, false, 0);
        vbox.pack_start(grid, true, false, 0);
        vbox.pack_start(clabel, true, false, 0);
        vbox.pack_start(this.entry, false, false, 0);
        this.show_all();
    }
});
