const GObject = imports.gi.GObject;
const Clutter = imports.gi.Clutter;
const GLib = imports.gi.GLib;

var Y901xSeekBar = GObject.registerClass({
    GTypeName: "Y901xSeekBar"
}, class Y901xSeekBar extends Clutter.Actor {
    constructor(props={}) {
        super(props);
    }
    create() {
        this.set_background_color(Clutter.Color.new(20, 20, 20, 125));
        this.canvas = new Clutter.Actor();
        this.canvas.set_background_color(Clutter.Color.new(255, 0, 0, 125));
        this.canvas.set_position(0, 0);
        this.canvas.set_size(0, 30);
        this.add_child(this.canvas);
        this.time = new Clutter.Text({
            color: Clutter.Color.new(255, 255, 255, 255),
            text: "00:00/00:00"
        });
        this.add_child(this.time);
    }
    set_time(sec, all, prog) {
        // Seekbar
        this.canvas.set_size(Math.round(prog * this.width), 22);
        // Label
        let sectime = GLib.DateTime.new_from_unix_utc(sec);
        let alltime = GLib.DateTime.new_from_unix_utc(all);
        let s,t = 0;
        if (alltime.get_hour() > 0) {
            s = sectime.format("%H:%M:%S");
            t = alltime.format("%H:%M:%S");
        } else {
            s = sectime.format("%M:%S");
            t = alltime.format("%M:%S");
        }
        this.time.set_text(s + "/" + t);
    }
    set_progress(all, prog) {
        this.set_time(all * prog, all, prog);
    }
});
