const GObject = imports.gi.GObject;
const Gtk = imports.gi.Gtk;

var Y901xShortcutsWindow = GObject.registerClass({
    GTypeName: "Y901ShortcutWindow"
}, class Y901xShortcutsWindow extends Gtk.ShortcutsWindow {
    constructor(props={}) {
        super(props);
    }
    create() {
        let section = new Gtk.ShortcutsSection({
            visible: true,
            max_height: 10,
            section_name: "Name"
        });
        //
        // Play
        //
        let play = new Gtk.ShortcutsGroup({
            title: "Play/Paused"
        });
        play.add(new Gtk.ShortcutsShortcut({
            accelerator: "space",
            title: "Play/Paused"
        }));
        play.add(new Gtk.ShortcutsShortcut({
            accelerator: "F11",
            title: "Change FullScreen"
        }));
        play.add(new Gtk.ShortcutsShortcut({
            accelerator: "Escape",
            title: "Quit or Release FullScreen"
        }));
        section.add(play);
        //
        // List
        //
        let list = new Gtk.ShortcutsGroup({
            title: "List"
        });
        list.add(new Gtk.ShortcutsShortcut({
            accelerator: "F7",
            title: "Repeat Single"
        }));
        list.add(new Gtk.ShortcutsShortcut({
            accelerator: "F8",
            title: "Repeat Listup"
        }));
        list.add(new Gtk.ShortcutsShortcut({
            accelerator: "Up",
            title: "Play the Previous File"
        }));
        list.add(new Gtk.ShortcutsShortcut({
            accelerator: "Down",
            title: "Play the Next File"
        }));
        section.add(list);
        //
        // Size
        //
        let size = new Gtk.ShortcutsGroup({
            title: "Video Size"
        });
        let size_array = ["x1", "x2", "x3", "x0.5", "x1.5", "x2.5", "set1", "set2", "set3"];
        for (let i=0; i<size_array.length; i++) {
            size.add(new Gtk.ShortcutsShortcut({
                accelerator: (i + 1).toString(),
                title: size_array[i]
            }));
        }
        section.add(size);
        this.add(section);
    }
});
